/*
 * imgweight.c
 *
 * Code generation for function 'imgweight'
 *
 * C source code generated on: Thu Jan 12 20:55:50 2012
 *
 */

/* Include files */
#include "imgweight.h"
#include <stdio.h>

/* Type Definitions */
#ifndef struct_emxArray__common
#define struct_emxArray__common

typedef struct emxArray__common
{
  void *data;
  int32_T *size;
  int32_T allocatedSize;
  int32_T numDimensions;
  boolean_T canFreeData;
} emxArray__common;

#endif

#ifndef struct_emxArray_real_T
#define struct_emxArray_real_T

typedef struct emxArray_real_T
{
  real_T *data;
  int32_T *size;
  int32_T allocatedSize;
  int32_T numDimensions;
  boolean_T canFreeData;
} emxArray_real_T;

#endif

/* Named Constants */

/* Variable Declarations */
real_T f[76800];
real_T n;
real_T mt[76800];
real_T y[1996800];
real_T w[26];
real_T normface[76800];

/* Variable Definitions */

/* Function Declarations */
static void dot(const real_T a[1996800], const emxArray_real_T *b, real_T c[26]);
static void emxEnsureCapacity(emxArray__common *emxArray, int32_T oldNumel,
  int32_T elementSize);
static void emxFree_real_T(emxArray_real_T **pEmxArray);
static void emxInit_real_T(emxArray_real_T **pEmxArray, int32_T numDimensions);

/* Function Definitions */

/*
 *
 */
static void dot(const real_T a[1996800], const emxArray_real_T *b, real_T c[26])
{
  int32_T i2;
  int32_T ic;
  int32_T i;
  int32_T i1;
  real_T b_c;
  int32_T iy;
  int32_T k;
  i2 = -1;
  ic = -1;
  for (i = 0; i < 26; i++) {
    i1 = i2 + 1;
    ic++;
    i2 += 76800;
    b_c = 0.0;
    iy = i1;
    for (k = 0; k < 76800; k++) {
      b_c += a[i1] * b->data[iy];
      i1++;
      iy++;
    }

    c[ic] = b_c;
  }
}

static void emxEnsureCapacity(emxArray__common *emxArray, int32_T oldNumel,
  int32_T elementSize)
{
  int32_T newNumel;
  int32_T loop_ub;
  int32_T i;
  void *newData;
  newNumel = 1;
  loop_ub = emxArray->numDimensions - 1;
  for (i = 0; i <= loop_ub; i++) {
    newNumel *= emxArray->size[i];
  }

  if (newNumel > emxArray->allocatedSize) {
    loop_ub = emxArray->allocatedSize;
    if (loop_ub < 16) {
      loop_ub = 16;
    }

    while (loop_ub < newNumel) {
      loop_ub <<= 1;
    }

    newData = calloc((uint32_T)loop_ub, (uint32_T)elementSize);
    if (emxArray->data != NULL) {
      memcpy(newData, emxArray->data, (uint32_T)(elementSize * oldNumel));
      if (emxArray->canFreeData) {
        free(emxArray->data);
      }
    }

    emxArray->data = newData;
    emxArray->allocatedSize = loop_ub;
    emxArray->canFreeData = TRUE;
  }
}

static void emxFree_real_T(emxArray_real_T **pEmxArray)
{
  if (*pEmxArray != (emxArray_real_T *)NULL) {
    if ((*pEmxArray)->canFreeData) {
      free((void *)(*pEmxArray)->data);
    }

    free((void *)(*pEmxArray)->size);
    free((void *)*pEmxArray);
    *pEmxArray = (emxArray_real_T *)NULL;
  }
}

static void emxInit_real_T(emxArray_real_T **pEmxArray, int32_T numDimensions)
{
  emxArray_real_T *emxArray;
  int32_T loop_ub;
  int32_T i;
  *pEmxArray = (emxArray_real_T *)malloc(sizeof(emxArray_real_T));
  emxArray = *pEmxArray;
  emxArray->data = (real_T *)NULL;
  emxArray->numDimensions = numDimensions;
  emxArray->size = (int32_T *)malloc((uint32_T)(sizeof(int32_T) * numDimensions));
  emxArray->allocatedSize = 0;
  emxArray->canFreeData = TRUE;
  loop_ub = numDimensions - 1;
  for (i = 0; i <= loop_ub; i++) {
    emxArray->size[i] = 0;
  }
}

/*
 * function [ w,normface] = imgweight( f,n,mt,y )
 * final
 * Gives the wieght vector of of the face..
 * f is a MATRIX OF INTENSITY and not a image of any format..Sure it can work
 * in matlab but in real,we have to give a 480*640 Matrix of numbers
 */
void imgweight(const real_T f[76800], int8_T n, const real_T mt[76800], const
               real_T y[1996800], real_T w[26], real_T normface[76800])
{
  int32_T k;
  int8_T mv[2];
  int32_T iv0[2];
  emxArray_real_T *b;
  int32_T ib;
  int32_T jtilecol;
  int32_T ia;

  /* mt input varibale is the part of TRAINING STRUCTURE */
  /* y is the eigen space */
  /* n will be fixed */
  /* 'imgweight:13' f=double(f); */
  /* 'imgweight:14' [M,N]=size(f); */
  /* 'imgweight:15' T=reshape(f,M*N,1); */
  for (k = 0; k < 76800; k++) {
    /* reshaped new img */
    /*  S=mean(T);           %mean of the face */
    /* 'imgweight:20' normface=T-mt; */
    normface[k] = f[k] - mt[k];

  }

  /*  SECOND CHOICE IS TO SUBSTRACT MEANVECBOOK TO CREAT NORM FACe */
  /*  NOTE--TO CREATE NOMFACE,WE HAVE 3 MEAN OPTIONS */
  /*  1)--MeanFace */
  /*  2)--MeanVec */
  /*  3)--Mean of input img */
  /*  meanvecbook=mean(p.mx); */
  /*  meanvecbook=repmat(meanvecbook,M*N,1); */
  /*   normface=T-meanvecbook;  %this is working better */
  /* 'imgweight:30' w=dot(y,repmat(normface,1,n)); */
  mv[0] = 1;
  mv[1] = n;
  for (k = 0; k < 2; k++) {
    iv0[k] = (76800 + -76799 * k) * mv[k];
  }

  emxInit_real_T(&b, 2);
  k = b->size[0] * b->size[1];
  b->size[0] = 76800;
  b->size[1] = iv0[1];
  emxEnsureCapacity((emxArray__common *)b, k, (int32_T)sizeof(real_T));
  if (b->size[1] == 0) {
  } else {
    ib = 0;
    for (jtilecol = 1; jtilecol <= mv[1]; jtilecol++) {
      ia = 0;
      for (k = 0; k < 76800; k++) {
        b->data[ib] = normface[ia];
        ia++;
        ib++;
      }
    }
  }

  dot(y, b, w);
  emxFree_real_T(&b);
}

void imgweight_initialize(void)
{
}
main()
{


  float *m=(float *)0x807e9000; //According to bit depth        //pointer to buffer
  float *mf =(float *)0x8079e000;
  float *ef =(float *)0x80000000;
   int nPixel; //bit depth
       for ( nPixel = 0; nPixel < 76800; nPixel++ )
       {
          f[nPixel]=*m;
          m++;

       }
       int n1; //bit depth
              for ( n1 = 0; n1 < 76800; n1++ )
              {
                 mt[n1]=*mf;
                 mf++;

              }
              int n2; //bit depth
                           for ( n2 = 0; n2 < 1996800; n2++ )
                           {
                              y[n2]=*ef;
                              ef++;

                           }


n=26;
imgweight(f, n, mt,y,w,normface);
printf("Complete\n");
}

void imgweight_terminate(void)
{
  /* (no terminate code required) */
}

/* End of code generation (imgweight.c) */
